/*
  Funzione readline tratta da : Unix Network Programming Volume I di W.R. Stevens
  
  ConsideraziO: .... ne esiste addirittura una pi completa e veloce, ma direi 
                che questa per il momento ci basta :P
  
                                                                By ][^XaBaRaS^][
*/

#include <fcntl.h>
#include <errno.h>

ssize_t
readline(int fd, void *vptr, size_t maxlen)
{
	ssize_t n, rc;
	char      c, *ptr;

	ptr = vptr;
	for (n = 1; n < maxlen; n++) {
		again:
		     if ( (rc = read(fd, &c, 1)) == 1) {
			*ptr++ = c;
			if (c == '\n')
			     break;
		     } else if (rc == 0) {
			if (n == 1)
			     return (0);
		                else
			     break;
		     } else {
			if (errno = EINTR)
			     goto again;
			return (-1);
		     }
	}
	
	*ptr = 0;
	return (n);
}
